
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte #:nodoc:
unless defined?(::Tomte::BlankSlate)
  SAFE_METHODS = [:class, :inspect, :to_s, :object_id, :is_a?].freeze

  # breaks constant lookup
  # class BlankSlate < BasicObject; end if defined?(BasicObject)

  class BlankSlate #:nodoc:
    alias :__instance_eval :instance_eval

    instance_methods.each { |m|  undef_method m unless ( SAFE_METHODS.include?(m.to_sym) || m.to_s =~ /^__/) }

    def inspect
      "#{self.class.name}:#{self.__id__}"
    end

  end
end
end
