
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.


#require 'rails/script_tomte_loader'

# If we are inside a Rails application this method performs an exec and thus
# the rest of this script is not run.
#Tomte::ScriptTomteLoader.exec_script_tomte!

tomte_path = File.expand_path('../../lib', __FILE__)
$:.unshift(tomte_path) if File.directory?(tomte_path) && !$:.include?(tomte_path)

require 'thor'


module Tomte

  MODULES = ["tomte/cli", "tomte/cli/protocol", "tomte/cli/agents", "tomte/cli/tools"].freeze

  module Cli

    autoload :Plugin, "tomte/cli/plugin"

    class << self

      def load_submodules_cli

        Tomte::MODULES.each do |mod|
          begin
            require "#{mod}/base"
          rescue LoadError
            begin
              $:.unshift(File.join(Dir.getwd, 'lib'))
              require "#{mod}/base"
            rescue LoadError
            end
          end
        end
      end

    end

    Tomte::Cli.load_submodules_cli
  end
end
