# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte::Cli::Console
  extend Tomte::Cli::Plugin

  define_tasks do

    desc "console", "Boots up the Tomte irb/pry console."
    method_option :environment, :default => "development"
    method_option :debug, :default => false
    method_option "log-level", :default => nil

    def console(preload = nil)

     ARGV.clear

     try_require "tomte"
     prepare :console

     puts "=> Loading #{Tomte.env} console (Tomte v.#{Tomte::VERSION})".blue.bold

     begin
       load preload
       puts "Preloaded '#{preload}'"
     rescue LoadError
       puts "Failed to load '#{preload}'".important!
     end unless preload.nil?

     tomte_console.start
    end

    desc "pry", "Boots up the Tomte Pry console."
    def pry(*args)
      invoke(:console, args)
    end

  end
end
