
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte
  begin
    require 'pry'
  rescue LoadError
    raise "The Pry gem is required."
  end



  class Console

    def initialize

      # configure Pry to use awesome_print
      Pry.config.print = proc { |output, value| output.puts value.ai }
    end

    def start(binding = nil)
      @console = Pry.start(binding)
    end

    def prompt=(string)
      @console.prompt = string
    end



    def add_hook(hook, name, &block)
      ::Pry.config.hooks.add_hook(:hook, name, &block)
    end

  end

end