
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

# Simple RingBuffer implementation
#
# see class RingBufferTest below for usage examples
#

module Tomte
  module CoreStructures
    class RingBuffer < Array

      alias_method :array_push, :push
      alias_method :array_element, :[]

      def initialize( size )
        @ring_size = size
        super( )
      end

      def push( element )
        if length >= @ring_size
          shift # loose element
        end
        array_push element
      end

      # Access elements in the RingBuffer
      #
      # offset will be typically negative!
      #
      def []( offset = 0 )
        return self.array_element( - 1 + offset )
      end

      alias_method :<<, :push
    end
  end
end