# encoding: UTF-8
module Tomte
  module Document
    module Extensions
      module Binary
        def to_tomte(value)
          if value.instance_of?(::BSON::Binary)
            value
          elsif value.instance_of?(Tomte::Binary)
            ::BSON::Binary.new(value.to_s)
          else
            value.nil? ? nil : ::BSON::Binary.new(value)
          end
        end

        def from_tomte(value)
          if value.instance_of?(Tomte::Binary)
            value
          elsif value.instance_of?(::BSON::Binary)
            Tomte::Binary.new(value.to_s)
          else
            value
          end
        end
      end
    end
  end

  class Binary
    extend Tomte::Document::Extensions::Binary
  end
end
