# encoding: UTF-8
module Tomte
  module Document
    module Extensions
      module Boolean
        Mapping = {
          true    => true,
          'true'  => true,
          'TRUE'  => true,
          'True'  => true,
          't'     => true,
          'T'     => true,
          '1'     => true,
          1       => true,
          1.0     => true,
          false   => false,
          'false' => false,
          'FALSE' => false,
          'False' => false,
          'f'     => false,
          'F'     => false,
          '0'     => false,
          0       => false,
          0.0     => false,
          nil     => nil
        }

        def to_tomte(value)
          if value.is_a?(Boolean)
            value
          else
            Mapping[value]
          end
        end

        def from_tomte(value)
          value.nil? ? nil : !!value
        end
      end
    end
  end
end

class Boolean
  extend Tomte::Document::Extensions::Boolean
end