# encoding: UTF-8

module Tomte
  module Document
    module Extensions
      module Exception
        module ClassMethods

          def to_tomte(value)

            return if value.nil?
            return value unless value.is_a?(::Exception)

            { :_type => value.class.name,
              :message => value.message,
              :backtrace => (value.backtrace || []),
              :attributes => value.instance_variables.inject_hash do |h, var|
                h[var.to_s[1..-1].to_sym] = Tomte::Document::Parser.to_tomte_hash( value.instance_variable_get(var))
              end
            }
          end

          def from_tomte(value)
            return value if value.nil? || !value.is_a?(::Hash)
            attrs = value.symbolize_keys

            Tomte::Document::Parser.load_exception(attrs[:_type],
                                                   attrs[:message],
                                                   attrs[:backtrace],
                                                   attrs[:attributes])
          end
        end

        module InstanceMethods
          def to_tomte
            self.class.to_tomte(self)
          end
        end
      end
    end
  end
end



class Exception
  extend Tomte::Document::Extensions::Exception::ClassMethods
  include Tomte::Document::Extensions::Exception::InstanceMethods
end


