# encoding: UTF-8

module Tomte
  module Document
    module Extensions
      module Hash
        module ClassMethods
          def to_tomte(value)
            return if value.nil?
            begin
              value.inject({}) do |h,(k,v)|
                 h[k] = Tomte::Document::Parser.to_tomte_hash(v)
#                h[k] = (v.respond_to?(:to_tomte) ? v.to_tomte : v)
#                h[k][:_type] ||= v.class.name if (h[k].is_a?(::Hash) &&
#                    !Tomte::Document::Parser.is_document?(h[k])) &&
#                    !Tomte::Document::Parser.is_generic_object?(v)
                h
              end
#            rescue
#              value
            end
          end
          def from_tomte(value)
            (value || {}).inject(HashWithIndifferentAccess.new) do |h, (k,v)|
#              h[k] = (((v.kind_of?(::Hash)  ) && (v['_doctype'].present? || v[:_doctype].present?)) ?
#                  Tomte::Document::Parser.load(v) : v)
              h[k] =  Tomte::Document::Parser.load(v)
                #if Tomte::Document::Parser.is_document?(v)
                #  Tomte::Document::Parser.load(v)
                #elsif Tomte::Document::Parser.is_generic_object?(v)
                #  Tomte::Document::Parser.load_generic_object(v)
                #else
                #  v
                #end
              h
            end
          end
        end
        module InstanceMethods
          def to_tomte
            self.class.to_tomte(self)
          end
        end
      end
    end
  end
end

class Hash
  extend Tomte::Document::Extensions::Hash::ClassMethods
  include Tomte::Document::Extensions::Hash::InstanceMethods
end

class ActiveSupport::HashWithIndifferentAccess < Hash
  extend Tomte::Document::Extensions::Hash::ClassMethods
  include Tomte::Document::Extensions::Hash::InstanceMethods
end