
# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

require 'bson'
require 'uuidtools'

module Tomte

  class ObjectId < BSON::ObjectId
    alias_method :original_to_json, :to_json


    def inspect
      "ObjectId:('#{to_s}')"
    end

    def awesome_format
      "Id:#{to_s}"
    end


    def as_json(options=nil)
      to_s
    end

    def to_json(options = nil)
      as_json.to_json
    end

  end
end

