require 'forwardable'
require 'compat/ostruct'

module Tomte

  class OpenDocument < OpenStruct

    alias_method :openstruct_initialize, :initialize
    include Tomte::Document

    key :table, Hash


    def self.from_tomte(data)

      # hack XXX have a second look

      return data if data.is_a?(self)
      (data.respond_to?(:include?) && (data.include?(:_id) || data.include?('_id') )) ? super : new(data)
    end

    def method_missing(mid, *args) # :nodoc:
      super unless table.nil?
    end


    def initialize(hash = nil, &block)
      super nil
      openstruct_initialize(hash, &block)

      if block
        yield self
      end
    end

  end
end