
require 'mime/types'

# Tomte, a framework for distributed agents.
# Copyright (c) 2010-2013, Lele Forzani, windmillmedia. All Rights Reserved.
#
# Author:: Lele Forzani <lele@windmill.it>
# License:: You can redistribute it and/or modify it under the terms of the LICENSE file.

module Tomte

  class << self
    def random_id
      UUIDTools::UUID.random_create.to_s
    end
  end

  module MIME
    class Type < ::MIME::Type
      PARAMETERS_RE = %r{([-\w.+]+)=([-\w.+]*)}o

      attr_accessor :parameters

      def add_parameters(params)
        @parameters = @parameters.merge(params)
        type = content_type.split(';').first
        @content_type = "#{type}; " + parameters.map{|k,v| "#{k}=#{v}"}.join('; ')
      end

      def initialize(content_type)
        super

        @parameters = {}

        content_type.split(';').each do |data|
          matchdata = PARAMETERS_RE.match(data)
          if matchdata
            parameters[matchdata.captures[0].to_sym] = matchdata.captures[1].to_s
          end
        end
      end
    end
  end

end
